import { StateChanger, Subscriber } from './Interfaces';
import State from './State';
import StateChangerManager from './StateChangerManager';
import SubscriberManager from './SubscriberManager';
export default class StateContainer {
    protected debug: boolean;
    protected stateChangerManager: StateChangerManager;
    protected subscriberManager: SubscriberManager;
    protected state: State;
    constructor(initialState?: {
        [key: string]: any;
    }, debug?: boolean);
    registerStateChanger(stateChanger: StateChanger): void;
    unregisterStateChanger(stateChanger: StateChanger): void;
    registerSubscriber(subscriber: Subscriber, notifyOnSubscribe?: boolean): number;
    unregisterSubscriber(subscriberId: number): void;
    triggerChange(changes: {
        [key: string]: any;
    }, stateChangerName: string): void;
    protected updateState(newState: State): void;
    currentStateCopy: State;
    registeredStateChangers: Array<string>;
    subscribersCount: number;
}
